package com.muyu.context;

import com.muyu.common.security.utils.SecurityUtils;
import com.muyu.domain.EngineMaintenance;
import com.muyu.domain.EngineVersion;
import org.springframework.stereotype.Component;

import java.text.SimpleDateFormat;
import java.util.Date;

@Component
public class GenerateConstant {


    public static final String DATA_FIELD = "DataEngineValueActuator";
    public static final String DATA_RECORD = "DataEngineRecordActuator";
    public static final String DATA_SET = "DataEngineSetActuator";
    public static final String ACTION_IMPORT = "import com.muyu.abstracts.DataValue;";
    public static final String SCOPE_IMPORT = "import com.muyu.abstracts.DataEngineValueActuator;";
    public static final String PACKAGE_PATH = "package com.muyu.abstracts;\n";


    public static String getClassName(String versionCode) {
        String[] splits = versionCode.split("_");
        String className = "";
        for (String split : splits) {
            className += split.substring(0, 1).toUpperCase() + split.substring(1);
        }
        return className;
    }

    public static String generateConstant(EngineMaintenance ruleData, EngineVersion ruleVersion) {
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
        String format = simpleDateFormat.format(new Date());
        return "package com.muyu.domain.EngineVersion;\n" +
                "import com.muyu.abstracts.DataEngineValueActuator;\n" +
                "import com.muyu.abstracts.DataValue;\n" +
                "\n" +
                "/**\n" +
                " * @Author: " + "qdm" + "\n" +
                " * @date: " + format + "\n" +
                " * @Description: " + "\n" +
                " * @Version: 1.0\n" +
                " */\n" +
                "public class " + ruleVersion.getName() + " extends " + "DataEngineValueActuator" + "{ \n" +
                "    @Override\n" +
                "    public DataValue run () {\n" +
                "       DataValue dataValue = get();\n" +
                "        if(dataValue.getValue()==null || dataValue.getValue().equals(\"\")){\n" +
                "            System.out.println(\"数据为空,需要丢弃\");\n" +
                "        }else{ \n" +
                "            System.out.println(\"数据非空：\"+dataValue.getValue());\n" +
                "        }\n" +
                "        return dataValue;\n" +
                "    }\n" +
                "}";
    }


}
