package com.muyu.req;

import com.muyu.common.core.web.domain.BaseEntity;
import com.muyu.domain.EngineVersion;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.util.List;

/**
 * ：qdm
 *
 * @Package：com.muyu.req
 * @Project：cloud-etl-engine
 * @name：EngineVersionListResp
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@SuperBuilder
public class EngineVersionListResp extends BaseEntity {
    /**
     * 编号
     */
    private Long id;

    /**
     * 名称
     */
    private String name;

    /**
     * 类型
     */
    private Integer type;

    /**
     * 作用域
     */
    private Integer scope;

    /**
     * 引擎编码
     */
    private String engineCode;

    /**
     * 是否激活
     */
    private String isActivate;

    /**
     * 状态
     */
    private String status;

    /**
     * 描述
     */
    private String description;

    /**
     * 规则引擎版本列表
     */
    private List<EngineVersion> engineVersionList;
}
