package com.muyu.service.serviceImpl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.muyu.common.core.utils.StringUtils;
import com.muyu.domain.EngineType;
import com.muyu.domain.constants.Result;
import com.muyu.mapper.TypseMapper;
import com.muyu.service.TypeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class TypeServiceImpl extends ServiceImpl<TypseMapper, EngineType> implements TypeService {
    @Autowired
    TypseMapper typseMapper;

    @Override
    public List<EngineType> list() {
        List<EngineType> list = typseMapper.list();
        return list;
    }

    @Override
    public Result add(EngineType type) {
        if (type.getName() == null || type.getName() == "") {
            return Result.error("类型名称不能为空");
        }
        if (StringUtils.isNotEmpty(typseMapper.selectByName(type.getName()))) {
            return Result.error("类型名称不能重复");
        }
        if (type.getName().length() < 1 || type.getName().length() > 20) {
            return Result.error("类型名称长度必须在2-10之间");
        }
        Integer res = typseMapper.add(type);
        return Result.success(res);
    }

    @Override
    public Result update(EngineType type) {
        Integer res = typseMapper.update(type);
        return Result.success(res);
    }

    @Override
    public Result delete(Integer id) {
        Integer res = typseMapper.delete(id);
        return Result.success(res);
    }

    @Override
    public Result deletes(String id) {
        Integer res = typseMapper.deletes(id);
        return Result.success(res);
    }
}
