package com.muyu.utils;

import com.aliyun.oss.OSS;
import com.aliyun.oss.OSSClientBuilder;
import com.aliyun.oss.model.PutObjectRequest;
import com.muyu.common.core.domain.Result;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.nio.charset.StandardCharsets;

/**
 * @Author：LiDongJia
 * @Package：com.muyu.cloud.etl.rule.upload
 * @Project：cloud-rule
 * @name：ALiYunUpload
 * @Date：2024/8/30
 */
public class OssUpload {

    // Endpoint以华东1（杭州）为例，其它Region请按实际情况填写
    private static final String endpoint = "https://oss-cn-shanghai.aliyuncs.com";

    private static final String accessKeyId = "LTAI5t8LmMHfW8ckPaAZR6oQ";

    private static final String accessKeySecret = "pwzEwkpxcTFgurkARyr7sG7V6syc9x";

    private static final String bucketName = "011811";
    // Bucket名称

    public static Result<Object> uploadFiles(String content, String fileName) {

        OSS ossClient = new OSSClientBuilder().build(endpoint, accessKeyId, accessKeySecret);

        // 上传到OSS后文件保存的目录，例如：folder/subfolder/，最后以斜杠结尾
        String objectName = "build/rule/version/" + fileName + ".java";

        try {
            // 将内容转换为字节数组输入流
            ByteArrayInputStream inputStream = new ByteArrayInputStream(content.getBytes(StandardCharsets.UTF_8));

            // 构造上传请求
            PutObjectRequest putObjectRequest = new PutObjectRequest(bucketName, objectName, inputStream);

            // 执行上传操作
//            ossClient.putObject(putObjectRequest);

            return Result.success(null, "文件" + fileName + ".java" + "存储成功");

        } catch (Exception e) {
            e.printStackTrace();

            return Result.error(null, "文件" + fileName + ".java" + "存储失败");
        } finally {
            // 关闭OSSClient
            if (ossClient != null) {
                ossClient.shutdown();
            }
        }

    }

    public static Result<Object> uploadClassFiles(String versionClass) {
        // 创建OSSClient实例。
        OSS ossClient = new OSSClientBuilder().build(endpoint, accessKeyId, accessKeySecret);

        try {
            // 填写Object完整路径，例如exampledir/exampleobject.txt。Object完整路径中不能包含Bucket名称。
            String objectName = "build/rule/version/" + versionClass + ".class";

            // 创建上传文件的输入流（这里以文件为例）。
            File file = new File("/home/lib/com/muyu/cloud/rule/engine/" + versionClass + ".class");

            // 上传文件。
            ossClient.putObject(new PutObjectRequest(bucketName, objectName, file));

            System.out.println("上传成功");
            return Result.success("上传成功");
        } catch (Exception e) {
            e.printStackTrace();
            System.out.println("上传失败");
            return Result.error("上传失败");
        } finally {
            // 关闭OSSClient。
            if (ossClient != null) {
                ossClient.shutdown();
            }
        }
    }

}
